class Game:
    def __init__(self, grid_size) -> None:
        self.grid_size = grid_size
        self.grid = [[i for i in range(grid_size)] for j in range(grid_size)]
        self.player_coord = [0, 0]
        self.lost = False
        self.current_direction = "right"

    def move(self, direction):
        """sumary_line

        Keyword arguments:
        direction: key pressed by the user
        Return: none
        """

        if direction == "left arrow" and self.check_move(
            self.player_coord[0] - 1, self.player_coord[1]
        ):
            self.player_coord[0] -= 1
            self.current_direction = "left"
        elif direction == "right arrow" and self.check_move(
            self.player_coord[0] + 1, self.player_coord[1]
        ):
            self.player_coord[0] += 1
            self.current_direction = "right"
        elif direction == "up arrow" and self.check_move(
            self.player_coord[0], self.player_coord[1] - 1
        ):
            self.player_coord[1] -= 1
            self.current_direction = "up"
        elif direction == "down arrow" and self.check_move(
            self.player_coord[0], self.player_coord[1] + 1
        ):
            self.player_coord[1] += 1
            self.current_direction = "down"
        else:
            self.lost = True

        return self

    def exit_game(self):
        self.lost = True

    """
    check if the move is still in the grid
    """

    def check_move(self, coordX, coordY):
        if (
            coordX >= 0
            and coordX <= len(self.grid) - 1
            and coordY >= 0
            and coordY <= len(self.grid[0]) - 1
        ):
            return True
        else:
            return False

    def step(self):
        self.move(self.current_direction + " arrow")
